//
// This code was generated by Enunciate.
// http://enunciate.codehaus.org/
//
#include <libxml/xmlwriter.h>
#include <libxml/xmlreader.h>
#include <Foundation/Foundation.h>

#ifndef DEBUG_ENUNCIATE
//turn off enunciate debugging.
#define DEBUG_ENUNCIATE 0
#endif

/**
 * Enunciate-specific interfaces and protocols.
 */
#ifndef ENUNCIATE_OBJC_TYPES
#define ENUNCIATE_OBJC_TYPES

/**
 * Protocol defining an Enunciate XML I/O methods.
 */
@protocol EnunciateXML

/**
 * Read an instance from XML.
 *
 * @param xml The XML to read.
 */
+ (id<EnunciateXML>) readFromXML: (NSData *) xml;

/**
 * Write this instance as XML.
 *
 * @return The XML.
 */
- (NSData *) writeToXML;

@end /*protocol EnunciateXML*/


/**
 * A basic XML node. Can be an element or an attribute. Used
 * instead of NSXMLElement because it's not supported on all
 * platforms yet.
 */
@interface JAXBBasicXMLNode : NSObject
{
  @private
    NSString *_name;
    NSString *_ns;
    NSString *_prefix;
    NSString *_value;
    NSArray  *_childElements;
    NSArray  *_attributes;
}

/**
 * Accessor for the (local) name of the XML node.
 *
 * @return The (local) name of the XML node.
 */
- (NSString *) name;

/**
 * Accessor for the (local) name of the XML node.
 *
 * @param newName The (local) name of the XML node.
 */
- (void) setName: (NSString *) newName;

/**
 * Accessor for the namespace of the XML node.
 *
 * @return The namespace of the XML node.
 */
- (NSString *) ns;

/**
 * Accessor for the namespace of the XML node.
 *
 * @param newNs The namespace of the XML node.
 */
- (void) setNs: (NSString *) newNs;

/**
 * Accessor for the namespace prefix of the XML node.
 *
 * @return The namespace prefix of the XML node.
 */
- (NSString *) prefix;

/**
 * Accessor for the namespace prefix of the XML node.
 *
 * @param newPrefix The namespace prefix of the XML node.
 */
- (void) setPrefix: (NSString *) newPrefix;

/**
 * Accessor for the value of the XML node.
 *
 * @return The value of the XML node.
 */
- (NSString *) value;

/**
 * Accessor for the value of the XML node.
 *
 * @param newValue The value of the XML node.
 */
- (void) setValue: (NSString *) newValue;

/**
 * Accessor for the child elements of the XML node.
 *
 * @return The child elements of the XML node.
 */
- (NSArray *) childElements;

/**
 * Accessor for the child elements of the XML node.
 *
 * @param newValue The child elements of the XML node.
 */
- (void) setChildElements: (NSArray *) newChildElements;

/**
 * Accessor for the attributes of the XML node.
 *
 * @return The attributes of the XML node.
 */
- (NSArray *) attributes;

/**
 * Accessor for the attributes of the XML node.
 *
 * @param newAttributes The attributes of the XML node.
 */
- (void) setAttributes: (NSArray *) newAttributes;
@end /*interface JAXBBasicXMLNode*/

#endif /* ENUNCIATE_OBJC_TYPES */


@class SECURITY_REST_APINS0AuthenticationLoginResourceResponse;
@class SECURITY_REST_APINS0ExternalRoleMappingResource;
@class SECURITY_REST_APINS0PlexusComponentListResource;
@class SECURITY_REST_APINS0PlexusRoleListResourceResponse;
@class SECURITY_REST_APINS0PlexusUserListResourceResponse;
@class SECURITY_REST_APINS0PlexusUserResourceResponse;
@class SECURITY_REST_APINS0PlexusUserSearchCriteriaResourceRequest;
@class SECURITY_REST_APINS0PrivilegeProperty;
@class SECURITY_REST_APINS0PrivilegeStatusResourceResponse;
@class SECURITY_REST_APINS0PrivilegeTypeResource;
@class SECURITY_REST_APINS0RoleListResourceResponse;
@class SECURITY_REST_APINS0RoleResourceRequest;
@class SECURITY_REST_APINS0UserChangePasswordRequest;
@class SECURITY_REST_APINS0UserForgotPasswordRequest;
@class SECURITY_REST_APINS0UserListResourceResponse;
@class SECURITY_REST_APINS0UserResourceRequest;
@class SECURITY_REST_APINS0UserToRoleResource;
@class SECURITY_REST_APINS0UserToRoleResourceRequest;
@class SECURITY_REST_APINS0UserResourceResponse;
@class SECURITY_REST_APINS0UserResource;
@class SECURITY_REST_APINS0UserForgotPasswordResource;
@class SECURITY_REST_APINS0UserChangePasswordResource;
@class SECURITY_REST_APINS0RoleResourceResponse;
@class SECURITY_REST_APINS0RoleResource;
@class SECURITY_REST_APINS0PrivilegeTypeResourceResponse;
@class SECURITY_REST_APINS0PrivilegeTypePropertyResource;
@class SECURITY_REST_APINS0PrivilegeStatusResource;
@class SECURITY_REST_APINS0PrivilegeListResourceResponse;
@class SECURITY_REST_APINS0PlexusUserSearchCriteriaResource;
@class SECURITY_REST_APINS0PlexusUserResource;
@class SECURITY_REST_APINS0PlexusRoleResource;
@class SECURITY_REST_APINS0PlexusComponentListResourceResponse;
@class SECURITY_REST_APINS0ExternalRoleMappingResourceResponse;
@class SECURITY_REST_APINS0ClientPermission;
@class SECURITY_REST_APINS0AuthenticationLoginResource;
@class SECURITY_REST_APINS0AuthenticationClientPermissions;

#ifndef DEF_SECURITY_REST_APINS0AuthenticationLoginResourceResponse_H
#define DEF_SECURITY_REST_APINS0AuthenticationLoginResourceResponse_H

/**
 *  REST Response object to list the privileges a users has.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0AuthenticationLoginResourceResponse : NSObject <EnunciateXML>
{
  @private
    SECURITY_REST_APINS0AuthenticationLoginResource *_data;
}

/**
 * Login details.
 */
- (SECURITY_REST_APINS0AuthenticationLoginResource *) data;

/**
 * Login details.
 */
- (void) setData: (SECURITY_REST_APINS0AuthenticationLoginResource *) newData;
@end /* interface SECURITY_REST_APINS0AuthenticationLoginResourceResponse */

#endif /* DEF_SECURITY_REST_APINS0AuthenticationLoginResourceResponse_H */
#ifndef DEF_SECURITY_REST_APINS0ExternalRoleMappingResource_H
#define DEF_SECURITY_REST_APINS0ExternalRoleMappingResource_H

/**
 *  A role mapping maps roles of one security realm to the default
 one.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0ExternalRoleMappingResource : NSObject
{
  @private
    SECURITY_REST_APINS0PlexusRoleResource *_defaultRole;
    NSArray *_mappedRoles;
}

/**
 * The systems's role.
 */
- (SECURITY_REST_APINS0PlexusRoleResource *) defaultRole;

/**
 * The systems's role.
 */
- (void) setDefaultRole: (SECURITY_REST_APINS0PlexusRoleResource *) newDefaultRole;

/**
 * Field mappedRoles.
 */
- (NSArray *) mappedRoles;

/**
 * Field mappedRoles.
 */
- (void) setMappedRoles: (NSArray *) newMappedRoles;
@end /* interface SECURITY_REST_APINS0ExternalRoleMappingResource */

#endif /* DEF_SECURITY_REST_APINS0ExternalRoleMappingResource_H */
#ifndef DEF_SECURITY_REST_APINS0PlexusComponentListResource_H
#define DEF_SECURITY_REST_APINS0PlexusComponentListResource_H

/**
 *  Details of a component used by the system.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0PlexusComponentListResource : NSObject
{
  @private
    NSString *_roleHint;
    NSString *_description;
}

/**
 * The hint of the component.
 */
- (NSString *) roleHint;

/**
 * The hint of the component.
 */
- (void) setRoleHint: (NSString *) newRoleHint;

/**
 * The description of the component.
 */
- (NSString *) description;

/**
 * The description of the component.
 */
- (void) setDescription: (NSString *) newDescription;
@end /* interface SECURITY_REST_APINS0PlexusComponentListResource */

#endif /* DEF_SECURITY_REST_APINS0PlexusComponentListResource_H */
#ifndef DEF_SECURITY_REST_APINS0PlexusRoleListResourceResponse_H
#define DEF_SECURITY_REST_APINS0PlexusRoleListResourceResponse_H

/**
 *  REST Response object that lists roles.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0PlexusRoleListResourceResponse : NSObject <EnunciateXML>
{
  @private
    NSArray *_data;
}

/**
 * Field data.
 */
- (NSArray *) data;

/**
 * Field data.
 */
- (void) setData: (NSArray *) newData;
@end /* interface SECURITY_REST_APINS0PlexusRoleListResourceResponse */

#endif /* DEF_SECURITY_REST_APINS0PlexusRoleListResourceResponse_H */
#ifndef DEF_SECURITY_REST_APINS0PlexusUserListResourceResponse_H
#define DEF_SECURITY_REST_APINS0PlexusUserListResourceResponse_H

/**
 *  REST Response object that lists users.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0PlexusUserListResourceResponse : NSObject <EnunciateXML>
{
  @private
    NSArray *_data;
}

/**
 * Field data.
 */
- (NSArray *) data;

/**
 * Field data.
 */
- (void) setData: (NSArray *) newData;
@end /* interface SECURITY_REST_APINS0PlexusUserListResourceResponse */

#endif /* DEF_SECURITY_REST_APINS0PlexusUserListResourceResponse_H */
#ifndef DEF_SECURITY_REST_APINS0PlexusUserResourceResponse_H
#define DEF_SECURITY_REST_APINS0PlexusUserResourceResponse_H

/**
 *  REST response object containing a user.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0PlexusUserResourceResponse : NSObject <EnunciateXML>
{
  @private
    SECURITY_REST_APINS0PlexusUserResource *_data;
}

/**
 * User's details.
 */
- (SECURITY_REST_APINS0PlexusUserResource *) data;

/**
 * User's details.
 */
- (void) setData: (SECURITY_REST_APINS0PlexusUserResource *) newData;
@end /* interface SECURITY_REST_APINS0PlexusUserResourceResponse */

#endif /* DEF_SECURITY_REST_APINS0PlexusUserResourceResponse_H */
#ifndef DEF_SECURITY_REST_APINS0PlexusUserSearchCriteriaResourceRequest_H
#define DEF_SECURITY_REST_APINS0PlexusUserSearchCriteriaResourceRequest_H

/**
 *  REST Request object to search for users based on criteria.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0PlexusUserSearchCriteriaResourceRequest : NSObject <EnunciateXML>
{
  @private
    SECURITY_REST_APINS0PlexusUserSearchCriteriaResource *_data;
}

/**
 * Search criteria.
 */
- (SECURITY_REST_APINS0PlexusUserSearchCriteriaResource *) data;

/**
 * Search criteria.
 */
- (void) setData: (SECURITY_REST_APINS0PlexusUserSearchCriteriaResource *) newData;
@end /* interface SECURITY_REST_APINS0PlexusUserSearchCriteriaResourceRequest */

#endif /* DEF_SECURITY_REST_APINS0PlexusUserSearchCriteriaResourceRequest_H */
#ifndef DEF_SECURITY_REST_APINS0PrivilegeProperty_H
#define DEF_SECURITY_REST_APINS0PrivilegeProperty_H

/**
 *  Key value pair.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0PrivilegeProperty : NSObject
{
  @private
    NSString *_key;
    NSString *_value;
}

/**
 * The key of the property.
 */
- (NSString *) key;

/**
 * The key of the property.
 */
- (void) setKey: (NSString *) newKey;

/**
 * The value of the property.
 */
- (NSString *) value;

/**
 * The value of the property.
 */
- (void) setValue: (NSString *) newValue;
@end /* interface SECURITY_REST_APINS0PrivilegeProperty */

#endif /* DEF_SECURITY_REST_APINS0PrivilegeProperty_H */
#ifndef DEF_SECURITY_REST_APINS0PrivilegeStatusResourceResponse_H
#define DEF_SECURITY_REST_APINS0PrivilegeStatusResourceResponse_H

/**
 *  REST response object containing a privilege.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0PrivilegeStatusResourceResponse : NSObject <EnunciateXML>
{
  @private
    SECURITY_REST_APINS0PrivilegeStatusResource *_data;
}

/**
 * Privilege details.
 */
- (SECURITY_REST_APINS0PrivilegeStatusResource *) data;

/**
 * Privilege details.
 */
- (void) setData: (SECURITY_REST_APINS0PrivilegeStatusResource *) newData;
@end /* interface SECURITY_REST_APINS0PrivilegeStatusResourceResponse */

#endif /* DEF_SECURITY_REST_APINS0PrivilegeStatusResourceResponse_H */
#ifndef DEF_SECURITY_REST_APINS0PrivilegeTypeResource_H
#define DEF_SECURITY_REST_APINS0PrivilegeTypeResource_H

/**
 *  Privilege type details. Used to dynamically define types of
 privileges.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0PrivilegeTypeResource : NSObject
{
  @private
    NSString *_id;
    NSString *_name;
    NSArray *_properties;
}

/**
 * The id of the privilege type.
 */
- (NSString *) id;

/**
 * The id of the privilege type.
 */
- (void) setId: (NSString *) newId;

/**
 * The name of the privilege type.
 */
- (NSString *) name;

/**
 * The name of the privilege type.
 */
- (void) setName: (NSString *) newName;

/**
 * Field properties.
 */
- (NSArray *) properties;

/**
 * Field properties.
 */
- (void) setProperties: (NSArray *) newProperties;
@end /* interface SECURITY_REST_APINS0PrivilegeTypeResource */

#endif /* DEF_SECURITY_REST_APINS0PrivilegeTypeResource_H */
#ifndef DEF_SECURITY_REST_APINS0RoleListResourceResponse_H
#define DEF_SECURITY_REST_APINS0RoleListResourceResponse_H

/**
 *  REST Response object for a role list request.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0RoleListResourceResponse : NSObject <EnunciateXML>
{
  @private
    NSArray *_data;
}

/**
 * Field data.
 */
- (NSArray *) data;

/**
 * Field data.
 */
- (void) setData: (NSArray *) newData;
@end /* interface SECURITY_REST_APINS0RoleListResourceResponse */

#endif /* DEF_SECURITY_REST_APINS0RoleListResourceResponse_H */
#ifndef DEF_SECURITY_REST_APINS0RoleResourceRequest_H
#define DEF_SECURITY_REST_APINS0RoleResourceRequest_H

/**
 *  REST Request object to persist a role.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0RoleResourceRequest : NSObject <EnunciateXML>
{
  @private
    SECURITY_REST_APINS0RoleResource *_data;
}

/**
 * Role to persist.
 */
- (SECURITY_REST_APINS0RoleResource *) data;

/**
 * Role to persist.
 */
- (void) setData: (SECURITY_REST_APINS0RoleResource *) newData;
@end /* interface SECURITY_REST_APINS0RoleResourceRequest */

#endif /* DEF_SECURITY_REST_APINS0RoleResourceRequest_H */
#ifndef DEF_SECURITY_REST_APINS0UserChangePasswordRequest_H
#define DEF_SECURITY_REST_APINS0UserChangePasswordRequest_H

/**
 *  REST Request to change a user's password.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0UserChangePasswordRequest : NSObject <EnunciateXML>
{
  @private
    SECURITY_REST_APINS0UserChangePasswordResource *_data;
}

/**
 * Details needed to change a users's password.
 */
- (SECURITY_REST_APINS0UserChangePasswordResource *) data;

/**
 * Details needed to change a users's password.
 */
- (void) setData: (SECURITY_REST_APINS0UserChangePasswordResource *) newData;
@end /* interface SECURITY_REST_APINS0UserChangePasswordRequest */

#endif /* DEF_SECURITY_REST_APINS0UserChangePasswordRequest_H */
#ifndef DEF_SECURITY_REST_APINS0UserForgotPasswordRequest_H
#define DEF_SECURITY_REST_APINS0UserForgotPasswordRequest_H

/**
 *  REST Request to reset a user's password.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0UserForgotPasswordRequest : NSObject <EnunciateXML>
{
  @private
    SECURITY_REST_APINS0UserForgotPasswordResource *_data;
}

/**
 * Details needed to reset a users's password.
 */
- (SECURITY_REST_APINS0UserForgotPasswordResource *) data;

/**
 * Details needed to reset a users's password.
 */
- (void) setData: (SECURITY_REST_APINS0UserForgotPasswordResource *) newData;
@end /* interface SECURITY_REST_APINS0UserForgotPasswordRequest */

#endif /* DEF_SECURITY_REST_APINS0UserForgotPasswordRequest_H */
#ifndef DEF_SECURITY_REST_APINS0UserListResourceResponse_H
#define DEF_SECURITY_REST_APINS0UserListResourceResponse_H

/**
 *  REST Response object that lists users.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0UserListResourceResponse : NSObject <EnunciateXML>
{
  @private
    NSArray *_data;
}

/**
 * Field data.
 */
- (NSArray *) data;

/**
 * Field data.
 */
- (void) setData: (NSArray *) newData;
@end /* interface SECURITY_REST_APINS0UserListResourceResponse */

#endif /* DEF_SECURITY_REST_APINS0UserListResourceResponse_H */
#ifndef DEF_SECURITY_REST_APINS0UserResourceRequest_H
#define DEF_SECURITY_REST_APINS0UserResourceRequest_H

/**
 *  REST request object to persist a user.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0UserResourceRequest : NSObject <EnunciateXML>
{
  @private
    SECURITY_REST_APINS0UserResource *_data;
}

/**
 * User information.
 */
- (SECURITY_REST_APINS0UserResource *) data;

/**
 * User information.
 */
- (void) setData: (SECURITY_REST_APINS0UserResource *) newData;
@end /* interface SECURITY_REST_APINS0UserResourceRequest */

#endif /* DEF_SECURITY_REST_APINS0UserResourceRequest_H */
#ifndef DEF_SECURITY_REST_APINS0UserToRoleResource_H
#define DEF_SECURITY_REST_APINS0UserToRoleResource_H

/**
 *  Details to assign roles to a users.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0UserToRoleResource : NSObject
{
  @private
    NSString *_userId;
    NSString *_source;
    NSArray *_roles;
}

/**
 * The id of the user.
 */
- (NSString *) userId;

/**
 * The id of the user.
 */
- (void) setUserId: (NSString *) newUserId;

/**
 * The source of the user.
 */
- (NSString *) source;

/**
 * The source of the user.
 */
- (void) setSource: (NSString *) newSource;

/**
 * Field roles.
 */
- (NSArray *) roles;

/**
 * Field roles.
 */
- (void) setRoles: (NSArray *) newRoles;
@end /* interface SECURITY_REST_APINS0UserToRoleResource */

#endif /* DEF_SECURITY_REST_APINS0UserToRoleResource_H */
#ifndef DEF_SECURITY_REST_APINS0UserToRoleResourceRequest_H
#define DEF_SECURITY_REST_APINS0UserToRoleResourceRequest_H

/**
 *  REST Request object to assign a roles to a user.  Typically used
 when assigning roles to a user NOT managed by this system.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0UserToRoleResourceRequest : NSObject <EnunciateXML>
{
  @private
    SECURITY_REST_APINS0UserToRoleResource *_data;
}

/**
 * Details of request.
 */
- (SECURITY_REST_APINS0UserToRoleResource *) data;

/**
 * Details of request.
 */
- (void) setData: (SECURITY_REST_APINS0UserToRoleResource *) newData;
@end /* interface SECURITY_REST_APINS0UserToRoleResourceRequest */

#endif /* DEF_SECURITY_REST_APINS0UserToRoleResourceRequest_H */
#ifndef DEF_SECURITY_REST_APINS0UserResourceResponse_H
#define DEF_SECURITY_REST_APINS0UserResourceResponse_H

/**
 *  REST response object containing a user.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0UserResourceResponse : NSObject <EnunciateXML>
{
  @private
    SECURITY_REST_APINS0UserResource *_data;
}

/**
 * User information.
 */
- (SECURITY_REST_APINS0UserResource *) data;

/**
 * User information.
 */
- (void) setData: (SECURITY_REST_APINS0UserResource *) newData;
@end /* interface SECURITY_REST_APINS0UserResourceResponse */

#endif /* DEF_SECURITY_REST_APINS0UserResourceResponse_H */
#ifndef DEF_SECURITY_REST_APINS0UserResource_H
#define DEF_SECURITY_REST_APINS0UserResource_H

/**
 *  User's details.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0UserResource : NSObject
{
  @private
    NSString *_resourceURI;
    NSString *_userId;
    NSString *_password;
    NSString *_name;
    NSString *_status;
    NSString *_email;
    NSArray *_roles;
}

/**
 * The URI of the user.
 */
- (NSString *) resourceURI;

/**
 * The URI of the user.
 */
- (void) setResourceURI: (NSString *) newResourceURI;

/**
 * The id of the user.
 */
- (NSString *) userId;

/**
 * The id of the user.
 */
- (void) setUserId: (NSString *) newUserId;

/**
 * The password of the user (write only).
 */
- (NSString *) password;

/**
 * The password of the user (write only).
 */
- (void) setPassword: (NSString *) newPassword;

/**
 * The common name of the user.
 */
- (NSString *) name;

/**
 * The common name of the user.
 */
- (void) setName: (NSString *) newName;

/**
 * The status of the user. Available status: active, locked,
disabled.
 */
- (NSString *) status;

/**
 * The status of the user. Available status: active, locked,
disabled.
 */
- (void) setStatus: (NSString *) newStatus;

/**
 * The email address of the user.
 */
- (NSString *) email;

/**
 * The email address of the user.
 */
- (void) setEmail: (NSString *) newEmail;

/**
 * Field roles.
 */
- (NSArray *) roles;

/**
 * Field roles.
 */
- (void) setRoles: (NSArray *) newRoles;
@end /* interface SECURITY_REST_APINS0UserResource */

#endif /* DEF_SECURITY_REST_APINS0UserResource_H */
#ifndef DEF_SECURITY_REST_APINS0UserForgotPasswordResource_H
#define DEF_SECURITY_REST_APINS0UserForgotPasswordResource_H

/**
 *  Details needed to reset a users's password.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0UserForgotPasswordResource : NSObject
{
  @private
    NSString *_email;
    NSString *_userId;
}

/**
 * User's email address.
 */
- (NSString *) email;

/**
 * User's email address.
 */
- (void) setEmail: (NSString *) newEmail;

/**
 * User's id.
 */
- (NSString *) userId;

/**
 * User's id.
 */
- (void) setUserId: (NSString *) newUserId;
@end /* interface SECURITY_REST_APINS0UserForgotPasswordResource */

#endif /* DEF_SECURITY_REST_APINS0UserForgotPasswordResource_H */
#ifndef DEF_SECURITY_REST_APINS0UserChangePasswordResource_H
#define DEF_SECURITY_REST_APINS0UserChangePasswordResource_H

/**
 *  Details needed to change a users's password.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0UserChangePasswordResource : NSObject
{
  @private
    NSString *_userId;
    NSString *_oldPassword;
    NSString *_newPassword;
}

/**
 * User's id.
 */
- (NSString *) userId;

/**
 * User's id.
 */
- (void) setUserId: (NSString *) newUserId;

/**
 * User's old password.
 */
- (NSString *) oldPassword;

/**
 * User's old password.
 */
- (void) setOldPassword: (NSString *) newOldPassword;

/**
 * User's new password.
 */
- (NSString *) newPassword;

/**
 * User's new password.
 */
- (void) setNewPassword: (NSString *) newNewPassword;
@end /* interface SECURITY_REST_APINS0UserChangePasswordResource */

#endif /* DEF_SECURITY_REST_APINS0UserChangePasswordResource_H */
#ifndef DEF_SECURITY_REST_APINS0RoleResourceResponse_H
#define DEF_SECURITY_REST_APINS0RoleResourceResponse_H

/**
 *  REST Response object for role request.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0RoleResourceResponse : NSObject <EnunciateXML>
{
  @private
    SECURITY_REST_APINS0RoleResource *_data;
}

/**
 * Role returned.
 */
- (SECURITY_REST_APINS0RoleResource *) data;

/**
 * Role returned.
 */
- (void) setData: (SECURITY_REST_APINS0RoleResource *) newData;
@end /* interface SECURITY_REST_APINS0RoleResourceResponse */

#endif /* DEF_SECURITY_REST_APINS0RoleResourceResponse_H */
#ifndef DEF_SECURITY_REST_APINS0RoleResource_H
#define DEF_SECURITY_REST_APINS0RoleResource_H

/**
 *  Role configuration.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0RoleResource : NSObject
{
  @private
    NSString *_resourceURI;
    NSString *_id;
    NSString *_name;
    NSString *_description;
    int _sessionTimeout;
    NSArray *_roles;
    NSArray *_privileges;
    BOOL _userManaged;
}

/**
 * The URI of the role.
 */
- (NSString *) resourceURI;

/**
 * The URI of the role.
 */
- (void) setResourceURI: (NSString *) newResourceURI;

/**
 * The id of the role.
 */
- (NSString *) id;

/**
 * The id of the role.
 */
- (void) setId: (NSString *) newId;

/**
 * The name of the role.
 */
- (NSString *) name;

/**
 * The name of the role.
 */
- (void) setName: (NSString *) newName;

/**
 * The description of the role.
 */
- (NSString *) description;

/**
 * The description of the role.
 */
- (void) setDescription: (NSString *) newDescription;

/**
 * The sessionTimeout of the role (legacy, actual value not
used).
 */
- (int) sessionTimeout;

/**
 * The sessionTimeout of the role (legacy, actual value not
used).
 */
- (void) setSessionTimeout: (int) newSessionTimeout;

/**
 * Field roles.
 */
- (NSArray *) roles;

/**
 * Field roles.
 */
- (void) setRoles: (NSArray *) newRoles;

/**
 * Field privileges.
 */
- (NSArray *) privileges;

/**
 * Field privileges.
 */
- (void) setPrivileges: (NSArray *) newPrivileges;

/**
 * Flag that defines if a user can update this role (read-only).
 */
- (BOOL) userManaged;

/**
 * Flag that defines if a user can update this role (read-only).
 */
- (void) setUserManaged: (BOOL) newUserManaged;
@end /* interface SECURITY_REST_APINS0RoleResource */

#endif /* DEF_SECURITY_REST_APINS0RoleResource_H */
#ifndef DEF_SECURITY_REST_APINS0PrivilegeTypeResourceResponse_H
#define DEF_SECURITY_REST_APINS0PrivilegeTypeResourceResponse_H

/**
 *  REST Request object to lists the types of privilege in the
 system.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0PrivilegeTypeResourceResponse : NSObject <EnunciateXML>
{
  @private
    NSArray *_data;
}

/**
 * Field data.
 */
- (NSArray *) data;

/**
 * Field data.
 */
- (void) setData: (NSArray *) newData;
@end /* interface SECURITY_REST_APINS0PrivilegeTypeResourceResponse */

#endif /* DEF_SECURITY_REST_APINS0PrivilegeTypeResourceResponse_H */
#ifndef DEF_SECURITY_REST_APINS0PrivilegeTypePropertyResource_H
#define DEF_SECURITY_REST_APINS0PrivilegeTypePropertyResource_H

/**
 *  Privilege property details.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0PrivilegeTypePropertyResource : NSObject
{
  @private
    NSString *_id;
    NSString *_name;
    NSString *_helpText;
    NSString *_type;
}

/**
 * The id of the privilege property.
 */
- (NSString *) id;

/**
 * The id of the privilege property.
 */
- (void) setId: (NSString *) newId;

/**
 * The name of the privilege property.
 */
- (NSString *) name;

/**
 * The name of the privilege property.
 */
- (void) setName: (NSString *) newName;

/**
 * The help text of the privilege property.
 */
- (NSString *) helpText;

/**
 * The help text of the privilege property.
 */
- (void) setHelpText: (NSString *) newHelpText;

/**
 * The type of the privilege property.
 */
- (NSString *) type;

/**
 * The type of the privilege property.
 */
- (void) setType: (NSString *) newType;
@end /* interface SECURITY_REST_APINS0PrivilegeTypePropertyResource */

#endif /* DEF_SECURITY_REST_APINS0PrivilegeTypePropertyResource_H */
#ifndef DEF_SECURITY_REST_APINS0PrivilegeStatusResource_H
#define DEF_SECURITY_REST_APINS0PrivilegeStatusResource_H

/**
 *  Privilege details.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0PrivilegeStatusResource : NSObject
{
  @private
    NSString *_id;
    NSString *_resourceURI;
    NSString *_name;
    NSString *_description;
    NSString *_type;
    BOOL _userManaged;
    NSArray *_properties;
}

/**
 * The id of the privilege.
 */
- (NSString *) id;

/**
 * The id of the privilege.
 */
- (void) setId: (NSString *) newId;

/**
 * The URI of the privilege.
 */
- (NSString *) resourceURI;

/**
 * The URI of the privilege.
 */
- (void) setResourceURI: (NSString *) newResourceURI;

/**
 * The name of the privilege.
 */
- (NSString *) name;

/**
 * The name of the privilege.
 */
- (void) setName: (NSString *) newName;

/**
 * The description of the privilege.
 */
- (NSString *) description;

/**
 * The description of the privilege.
 */
- (void) setDescription: (NSString *) newDescription;

/**
 * The type of the privilege.
 */
- (NSString *) type;

/**
 * The type of the privilege.
 */
- (void) setType: (NSString *) newType;

/**
 * Flag that defines if a privilege can update this role
(read-only).
 */
- (BOOL) userManaged;

/**
 * Flag that defines if a privilege can update this role
(read-only).
 */
- (void) setUserManaged: (BOOL) newUserManaged;

/**
 * Field properties.
 */
- (NSArray *) properties;

/**
 * Field properties.
 */
- (void) setProperties: (NSArray *) newProperties;
@end /* interface SECURITY_REST_APINS0PrivilegeStatusResource */

#endif /* DEF_SECURITY_REST_APINS0PrivilegeStatusResource_H */
#ifndef DEF_SECURITY_REST_APINS0PrivilegeListResourceResponse_H
#define DEF_SECURITY_REST_APINS0PrivilegeListResourceResponse_H

/**
 *  REST Response object to list privileges.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0PrivilegeListResourceResponse : NSObject <EnunciateXML>
{
  @private
    NSArray *_data;
}

/**
 * Field data.
 */
- (NSArray *) data;

/**
 * Field data.
 */
- (void) setData: (NSArray *) newData;
@end /* interface SECURITY_REST_APINS0PrivilegeListResourceResponse */

#endif /* DEF_SECURITY_REST_APINS0PrivilegeListResourceResponse_H */
#ifndef DEF_SECURITY_REST_APINS0PlexusUserSearchCriteriaResource_H
#define DEF_SECURITY_REST_APINS0PlexusUserSearchCriteriaResource_H

/**
 *  User search criteria details.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0PlexusUserSearchCriteriaResource : NSObject
{
  @private
    NSString *_userId;
    BOOL _effectiveUsers;
}

/**
 * Partial user Id to search for.  Uses 'starts with' search.
So 'jcod' will match 'jcoder' but not 'cjcoder'.
 */
- (NSString *) userId;

/**
 * Partial user Id to search for.  Uses 'starts with' search.
So 'jcod' will match 'jcoder' but not 'cjcoder'.
 */
- (void) setUserId: (NSString *) newUserId;

/**
 * An effective user is one that can login to the system.
 */
- (BOOL) effectiveUsers;

/**
 * An effective user is one that can login to the system.
 */
- (void) setEffectiveUsers: (BOOL) newEffectiveUsers;
@end /* interface SECURITY_REST_APINS0PlexusUserSearchCriteriaResource */

#endif /* DEF_SECURITY_REST_APINS0PlexusUserSearchCriteriaResource_H */
#ifndef DEF_SECURITY_REST_APINS0PlexusUserResource_H
#define DEF_SECURITY_REST_APINS0PlexusUserResource_H

/**
 *  User's details.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0PlexusUserResource : NSObject
{
  @private
    NSString *_userId;
    NSString *_source;
    NSString *_name;
    NSString *_email;
    NSArray *_roles;
}

/**
 * The id of the user.
 */
- (NSString *) userId;

/**
 * The id of the user.
 */
- (void) setUserId: (NSString *) newUserId;

/**
 * The source of the role, i.e. what realm the user belongs to.
 */
- (NSString *) source;

/**
 * The source of the role, i.e. what realm the user belongs to.
 */
- (void) setSource: (NSString *) newSource;

/**
 * The common name of the user.
 */
- (NSString *) name;

/**
 * The common name of the user.
 */
- (void) setName: (NSString *) newName;

/**
 * The email address of the user.
 */
- (NSString *) email;

/**
 * The email address of the user.
 */
- (void) setEmail: (NSString *) newEmail;

/**
 * Field roles.
 */
- (NSArray *) roles;

/**
 * Field roles.
 */
- (void) setRoles: (NSArray *) newRoles;
@end /* interface SECURITY_REST_APINS0PlexusUserResource */

#endif /* DEF_SECURITY_REST_APINS0PlexusUserResource_H */
#ifndef DEF_SECURITY_REST_APINS0PlexusRoleResource_H
#define DEF_SECURITY_REST_APINS0PlexusRoleResource_H

/**
 *  Details of a security role.  A roles uniqueness is made up of an
 id and a source (where the role came from).
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0PlexusRoleResource : NSObject
{
  @private
    NSString *_roleId;
    NSString *_name;
    NSString *_source;
}

/**
 * The id of the role.
 */
- (NSString *) roleId;

/**
 * The id of the role.
 */
- (void) setRoleId: (NSString *) newRoleId;

/**
 * Field name.
 */
- (NSString *) name;

/**
 * Field name.
 */
- (void) setName: (NSString *) newName;

/**
 * The source id of the role.  Defines what source the role
came from.
 */
- (NSString *) source;

/**
 * The source id of the role.  Defines what source the role
came from.
 */
- (void) setSource: (NSString *) newSource;
@end /* interface SECURITY_REST_APINS0PlexusRoleResource */

#endif /* DEF_SECURITY_REST_APINS0PlexusRoleResource_H */
#ifndef DEF_SECURITY_REST_APINS0PlexusComponentListResourceResponse_H
#define DEF_SECURITY_REST_APINS0PlexusComponentListResourceResponse_H

/**
 *  REST Response object to list components.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0PlexusComponentListResourceResponse : NSObject <EnunciateXML>
{
  @private
    NSArray *_data;
}

/**
 * Field data.
 */
- (NSArray *) data;

/**
 * Field data.
 */
- (void) setData: (NSArray *) newData;
@end /* interface SECURITY_REST_APINS0PlexusComponentListResourceResponse */

#endif /* DEF_SECURITY_REST_APINS0PlexusComponentListResourceResponse_H */
#ifndef DEF_SECURITY_REST_APINS0ExternalRoleMappingResourceResponse_H
#define DEF_SECURITY_REST_APINS0ExternalRoleMappingResourceResponse_H

/**
 *  REST Response object to list role mappings.  A role mapping maps
 roles of one security realm to the default one.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0ExternalRoleMappingResourceResponse : NSObject <EnunciateXML>
{
  @private
    NSArray *_data;
}

/**
 * Field data.
 */
- (NSArray *) data;

/**
 * Field data.
 */
- (void) setData: (NSArray *) newData;
@end /* interface SECURITY_REST_APINS0ExternalRoleMappingResourceResponse */

#endif /* DEF_SECURITY_REST_APINS0ExternalRoleMappingResourceResponse_H */
#ifndef DEF_SECURITY_REST_APINS0ClientPermission_H
#define DEF_SECURITY_REST_APINS0ClientPermission_H

/**
 *  Permission details.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0ClientPermission : NSObject
{
  @private
    NSString *_id;
    int _value;
}

/**
 * Id of the permission.
 */
- (NSString *) id;

/**
 * Id of the permission.
 */
- (void) setId: (NSString *) newId;

/**
 * Privilege value: NONE = 0, READ = 1, UPDATE = 2, DELETE = 4,
CREATE = 8, or you can OR them together.
 */
- (int) value;

/**
 * Privilege value: NONE = 0, READ = 1, UPDATE = 2, DELETE = 4,
CREATE = 8, or you can OR them together.
 */
- (void) setValue: (int) newValue;
@end /* interface SECURITY_REST_APINS0ClientPermission */

#endif /* DEF_SECURITY_REST_APINS0ClientPermission_H */
#ifndef DEF_SECURITY_REST_APINS0AuthenticationLoginResource_H
#define DEF_SECURITY_REST_APINS0AuthenticationLoginResource_H

/**
 *  Wrapper around login details.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0AuthenticationLoginResource : NSObject
{
  @private
    SECURITY_REST_APINS0AuthenticationClientPermissions *_clientPermissions;
}

/**
 * Login details info.
 */
- (SECURITY_REST_APINS0AuthenticationClientPermissions *) clientPermissions;

/**
 * Login details info.
 */
- (void) setClientPermissions: (SECURITY_REST_APINS0AuthenticationClientPermissions *) newClientPermissions;
@end /* interface SECURITY_REST_APINS0AuthenticationLoginResource */

#endif /* DEF_SECURITY_REST_APINS0AuthenticationLoginResource_H */
#ifndef DEF_SECURITY_REST_APINS0AuthenticationClientPermissions_H
#define DEF_SECURITY_REST_APINS0AuthenticationClientPermissions_H

/**
 *  Login details info.
 
 @version $Revision$ $Date$

 */
@interface SECURITY_REST_APINS0AuthenticationClientPermissions : NSObject
{
  @private
    BOOL _loggedIn;
    NSString *_loggedInUsername;
    NSString *_loggedInUserSource;
    NSArray *_permissions;
}

/**
 * Flags if a user is logged in.
 */
- (BOOL) loggedIn;

/**
 * Flags if a user is logged in.
 */
- (void) setLoggedIn: (BOOL) newLoggedIn;

/**
 * The logged in user's id.
 */
- (NSString *) loggedInUsername;

/**
 * The logged in user's id.
 */
- (void) setLoggedInUsername: (NSString *) newLoggedInUsername;

/**
 * The logged in user's source.
 */
- (NSString *) loggedInUserSource;

/**
 * The logged in user's source.
 */
- (void) setLoggedInUserSource: (NSString *) newLoggedInUserSource;

/**
 * Field permissions.
 */
- (NSArray *) permissions;

/**
 * Field permissions.
 */
- (void) setPermissions: (NSArray *) newPermissions;
@end /* interface SECURITY_REST_APINS0AuthenticationClientPermissions */

#endif /* DEF_SECURITY_REST_APINS0AuthenticationClientPermissions_H */
